<template>
  <div class="todo">
    <a-form @submit.prevent="addTodo()">
      <a-input-group compact>
        <a-input v-model:value="newTodo" class="todo_input" name="newTodo" />
        <a-button html-type="submit" type="primary">{{
          $t(titleButton)
        }}</a-button>
      </a-input-group>
    </a-form>
    <br />
    <a-list bordered :data-source="todos">
      <template #renderItem="{ item, index }">
        <a-list-item class="todo_list"
          >{{ item }}
          <div>
            <a-button type="primary" shape="circle" @click="removeTodo(index)"
              >-</a-button
            >
            &nbsp;
            <a-button shape="circle" @click="editTodo(index)"
              ><EditOutlined
            /></a-button>
          </div>
        </a-list-item>
      </template>
      <template #header>
        <div>{{ $t("todoList.todoList") }}</div>
      </template>
    </a-list>
  </div>
</template>

<script lang="ts">
import { ref } from "vue";
import { EditOutlined } from "@ant-design/icons-vue";
export default {
  components: {
    EditOutlined,
  },
  name: "ToDo",
  setup() {
    const titleButton = ref("todoList.addToDo");
    const newTodo = ref("");
    const indexEdit = ref(-1);
    const todosData = JSON.parse(localStorage.getItem("todos") ?? "[]") || "";
    const todos = ref(todosData);

    function addTodo() {
      if (!newTodo.value) return;

      if (indexEdit.value >= 0) {
        todos.value[indexEdit.value] = newTodo.value;
        newTodo.value = "";
        indexEdit.value = -1;
        titleButton.value = "todoList.addToDo";
      } else {
        todos.value.push(newTodo.value);
        newTodo.value = "";
      }
      saveData();
    }

    function removeTodo(index: number) {
      todos.value.splice(index, 1);
      saveData();
    }
    function editTodo(index: number) {
      indexEdit.value = index;
      newTodo.value = todos.value[index];
      console.log("==>", index, todos.value[index], newTodo.value);
      titleButton.value = "todoList.editToDo";
      saveData();
    }
    function saveData() {
      const storageData = JSON.stringify(todos.value);
      localStorage.setItem("todos", storageData);
    }

    return {
      todos,
      newTodo,
      titleButton,
      addTodo,
      removeTodo,
      saveData,
      editTodo,
    };
  },
};
</script>

<style lang="scss">
.todo {
  &_list {
    display: flex !important;
  }

  &_input {
    width: 200px !important;
  }
}
</style>
